;a door that when entered will send mario upwards.
;act like #$25

print "hAɓƏɍs"

db $42
JMP return : JMP return : JMP return : JMP return : JMP return
JMP return : JMP return : JMP return : JMP main : JMP return

incsrc scroll_door_def.asm

;options defines that won't share with all other doors--------------------
!require_switch = $00	;>$00 = doesn't require p-switch to enter,
			; $01 = require p-switch to enter.
!switch_type 	= $14AD	;>$14AD = blue, $14AE = silver.
!small_door 	= $00	;>$00 = can be entered on any powerup,
			; $01 = only small mario can enter.


main:
	LDA !freeram_door_dir
	CMP #$03		;>if direction is down..
	BEQ exit_door		;>then call the exit code
if !require_switch = $01
	LDA !switch_type	;\if switch = off
	BEQ return		;/then return
endif
if !small_door = $01
	LDA $19			;\if other powerup rather than small
	BNE return		;/then return
endif
	CMP #$00		;>if already in door mode
	BNE return		;>return

	REP #$20		;\if mario is 4 pixels far to the left or further
	LDA $9A			;|or 3 pixels far to the right or further,
	AND #$FFF0		;|then return (this was used on the origional
	SEC : SBC #$0005	;|smw's door to prevent mario from entering from
	CMP $94			;|the very edge)
	BCS ret16bit		;|
	CLC : ADC #$0008	;|
	CMP $94			;|
	BCC ret16bit		;|
	SEP #$20		;/

	LDA $16			;\
	AND #$08		;|if enters door properly
	BEQ return		;|
	LDA $72			;|
	BNE return		;|
	LDA $1470		;| \plays wrong sound
	ORA $187A		;| |
	ORA $148F		;| |
	BNE wrong_sound		;/ /
	JSR center_player	;>call the centered player code
	LDA #!sound_numb	;\play door sound
	STA !ram_sound		;/
	STZ $7B			;\cancel speed
	STZ $7D			;/
	LDA #$01		;\set direction to go up
	STA !freeram_door_dir	;/
	RTL			;>and return
ret16bit:
	SEP #$20
return:
	RTL

exit_door:
	LDA #$00
	STA !freeram_door_dir	;>otherwise exit the door
	JSR center_player	;>center the player
	STZ $71			;>let the player able to move
	LDA #!sound_numb2	;\exit door sound
	STA !ram_sound2		;/
	STZ $7B			;\cancel speed
	STZ $7D			;/
	STZ $13F9		;>back to the front of layer
	STZ $73			;>reset ducking flag
	STZ $78			;>and become visible
	RTL
wrong_sound:
	LDA #$2A
	STA $1DFC
RTL
center_player:
	REP #$20
	LDA $9A		;\center horizontally
	AND #$FFF0	;|
	STA $94		;/

	LDA $98			;\center vertically
	AND #$FFF0		;|
	SEC : SBC #$0010	;|
	STA $96			;/
	SEP #$20
	RTS